<?php
/**
 * Mirasvit
 *
 * This source file is subject to the Mirasvit Software License, which is available at https://mirasvit.com/license/.
 * Do not edit or add to this file if you wish to upgrade the to newer versions in the future.
 * If you wish to customize this module for your needs.
 * Please refer to http://www.magentocommerce.com for more information.
 *
 * @category  Mirasvit
 * @package   mirasvit/module-email
 * @version   2.5.3
 * @copyright Copyright (C) 2023 Mirasvit (https://mirasvit.com/)
 */


declare(strict_types=1);


namespace Mirasvit\Email\Ui\Campaign\Form;

use Magento\Ui\DataProvider\AbstractDataProvider;
use Mirasvit\Email\Api\Data\CampaignInterface;
use Mirasvit\Email\Repository\CampaignRepository;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Framework\View\Element\UiComponent\ContextInterface;

class DataProvider extends AbstractDataProvider
{
    private $campaignRepository;

    private $uiComponentFactory;

    /**
     * @var array
     */
    protected $loadedData;

    private $context;

    public function __construct(
        ContextInterface $context,
        CampaignRepository $campaignRepository,
        UiComponentFactory $uiComponentFactory,
        string $name,
        string $primaryFieldName,
        string $requestFieldName,
        array $meta = [],
        array $data = []
    ) {
        $this->context = $context;
        $this->campaignRepository = $campaignRepository;
        $this->uiComponentFactory = $uiComponentFactory;
        $this->collection = $this->campaignRepository->getCollection();

        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);
    }

    /**
     * {@inheritdoc}
     */
    public function getMeta()
    {
        return parent::getMeta();
    }

    /**
     * {@inheritdoc}
     */
    public function getData()
    {
        if (isset($this->loadedData)) {
            return $this->loadedData;
        }

        /** @var CampaignInterface $item */
        foreach ($this->collection as $item) {
            $item = $this->campaignRepository->get((int)$item->getId());
            $result = $item->getData();

            $this->loadedData[$item->getId()] = $result;
        }

        return $this->loadedData;
    }
}
